## org.apache.ivy.util.extendable
Class UnmodifiableExtendableItem

    java.lang.Object
      org.apache.ivy.util.extendable.UnmodifiableExtendableItem

All Implemented Interfaces:
  ExtendableItem

Direct Known Subclasses:
  AbstractIncludeExcludeRule, ArtifactRevisionId, DefaultDependencyArtifactDescriptor, DefaultExtendableItem, ModuleRevisionId

    public class UnmodifiableExtendableItem

extends java.lang.Object
implements ExtendableItem

Constructor Summary
`UnmodifiableExtendableItem(java.util.Map stdAttributes, java.util.Map extraAttributes)`

Method Summary
`java.lang.String` `getAttribute(java.lang.String attName)` Gets the value of an attribute Can be used to access the value of a standard attribute (like organisation, revision) or of an extra attribute.
`java.util.Map` `getAttributes()` Returns a Map of all attributes of this extendable item, including standard and extra ones.
`java.lang.String` `getExtraAttribute(java.lang.String attName)` Gets the value of an extra attribute Can be used only to access the value of an extra attribute, not a standard one (like organisation, revision)
`java.util.Map` `getExtraAttributes()` Returns a Map of all extra attributes of this extendable item.
`java.util.Map` `getQualifiedExtraAttributes()` Returns a Map of all extra attributes of this extendable item.
`protected void` `setExtraAttribute(java.lang.String attName, java.lang.String attValue)`
`protected void` `setStandardAttribute(java.lang.String attName, java.lang.String attValue)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### UnmodifiableExtendableItem

    public UnmodifiableExtendableItem(java.util.Map stdAttributes,
                                      java.util.Map extraAttributes)

Method Detail

### getAttribute

    public java.lang.String getAttribute(java.lang.String attName)

  Description copied from interface: `ExtendableItem`
  Gets the value of an attribute Can be used to access the value of a standard attribute (like organisation, revision) or of an extra attribute.

  Specified by:
    `getAttribute` in interface `ExtendableItem`
  Parameters:
    `attName` - the name of the attribute to get
  Returns:
    the value of the attribute, null if the attribute doesn't exist

### getExtraAttribute

    public java.lang.String getExtraAttribute(java.lang.String attName)

  Description copied from interface: `ExtendableItem`
  Gets the value of an extra attribute Can be used only to access the value of an extra attribute, not a standard one (like organisation, revision)

  Specified by:
    `getExtraAttribute` in interface `ExtendableItem`
  Parameters:
    `attName` - the name of the extra attribute to get. This name can be either qualified or unqualified.
  Returns:
    the value of the attribute, null if the attribute doesn't exist

### setExtraAttribute

    protected void setExtraAttribute(java.lang.String attName,
                                     java.lang.String attValue)

### setStandardAttribute

    protected void setStandardAttribute(java.lang.String attName,
                                        java.lang.String attValue)

### getAttributes

    public java.util.Map getAttributes()

  Description copied from interface: `ExtendableItem`
  Returns a Map of all attributes of this extendable item, including standard and extra ones. The Map keys are attribute names as Strings, and values are corresponding attribute values (as String too). Extra attributes are included in unqualified form only.

  Specified by:
    `getAttributes` in interface `ExtendableItem`
  Returns:
    A Map instance containing all the attributes and their values.

### getExtraAttributes

    public java.util.Map getExtraAttributes()

  Description copied from interface: `ExtendableItem`
  Returns a Map of all extra attributes of this extendable item. The Map keys are unqualified attribute names as Strings, and values are corresponding attribute values (as String too)

  Specified by:
    `getExtraAttributes` in interface `ExtendableItem`
  Returns:
    A Map instance containing all the extra attributes and their values.
  See Also:
    `ExtendableItem.getQualifiedExtraAttributes()`

### getQualifiedExtraAttributes

    public java.util.Map getQualifiedExtraAttributes()

  Description copied from interface: `ExtendableItem`
  Returns a Map of all extra attributes of this extendable item.

  The Map keys are qualified attribute names as Strings, and values are corresponding attribute values (as String too).

  An attribute name is qualified with a namespace exactly the same way xml attributes are qualified. Thus qualified attribute names are of the form `prefix:name`

  Specified by:
    `getQualifiedExtraAttributes` in interface `ExtendableItem`
  Returns:
    A Map instance containing all the extra attributes and their values.
  See Also:
    `ExtendableItem.getExtraAttributes()`